diff --git a/lisp/replace.el b/lisp/replace.el
index ed81097e14..d39ebeca15 100644
--- a/lisp/replace.el
+++ b/lisp/replace.el
@@ -1305,8 +1305,11 @@ occur-mode-goto-occurrence
         (regexp occur-highlight-regexp))
     (pop-to-buffer (marker-buffer pos))
     (goto-char pos)
-    (let ((end-mk (save-excursion (re-search-forward regexp nil t))))
-      (occur--highlight-occurrence pos end-mk))
+    (when regexp
+      (let ((end-mk (if (stringp regexp)
+                        (save-excursion (re-search-forward regexp nil t))
+                      (line-end-position))))
+        (occur--highlight-occurrence pos end-mk)))
     (when buffer (next-error-found buffer (current-buffer)))
     (run-hooks 'occur-mode-find-occurrence-hook)))
 
@@ -1386,8 +1389,11 @@ occur-mode-display-occurrence
     (save-selected-window
       (select-window window)
       (goto-char pos)
-      (let ((end-mk (save-excursion (re-search-forward regexp nil t))))
-        (occur--highlight-occurrence pos end-mk))
+      (when regexp
+        (let ((end-mk (if (stringp regexp)
+                          (save-excursion (re-search-forward regexp nil t))
+                        (line-end-position))))
+          (occur--highlight-occurrence pos end-mk)))
       (next-error-found buffer (current-buffer))
       (run-hooks 'occur-mode-find-occurrence-hook))))
 
